package protocols;

import core.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.math.BigInteger;

public class INITXAV extends Protocol {
   
   public INITXAV (ObjectOutputStream oos) {
      super("core.Message" ,"core.MessageKey" ,"core.Nonce" );
      this.oos=oos;
      }
   
   public void run() {
      try {
         
         println("creating nonce na");
         createNewNonce("na");
         
         println("Building message m1");
         Message m1 =message();
         m0=message();
         m0.addMessage(message(agentFromId("A")));
         m0.addMessage(message(agentFromId("B")));
         m0.addMessage(message(nonceFromId("na")));
         println("Encrypting m0");
         m0.encrypt("RSA", getPublicKey(nameFromId("B")));
         m1.addMessage(m0);
         m0=message();
         m0.addMessage(message(agentFromId("A")));
         m0.addMessage(message(agentFromId("B")));
         m0.addMessage(message(nonceFromId("na")));
         println("Encrypting m0");
         m0.encrypt("RSA", getPublicKey(nameFromId("B")));
         println("Hashing m0");
         m0.hash("MD5");
         println("Encrypting m0");
         m0.encrypt("RSA", getPrivateKey(nameFromId("A")));
         m1.addMessage(m0);
         println("Sending message m1");
         put("B", m1.getString(),4000);
         
         println("waiting for m2");
         Message m2 = message(get("B"));
         println("Decrypting m2");
         m2.decrypt("RSA", getPrivateKey(nameFromId("A")));
         addParts(m2.getAllFields(),3);
         m0=getPart();
         setNameToId(m0.getString(),"A");
         m0=getPart();
         setNameToId(m0.getString(),"B");
         m0=getPart();
         setValueToNonce(m0.getString(),"na");
         
         
         writeObject(nameFromId("B"));
         writeObject(nonceFromId("na"));
         
         
         } catch (Exception e) {e.printStackTrace();System.exit(0);}
      }
   
   public static void subMain(String[] args,ObjectOutputStream oos) {
      INITXAV A = new INITXAV(oos);
      args=A.getArgs(args);
      A.start();
      }
   
   public String[] getArgs(String[] args) {
      try {
         if (args.length != 5) {
            args = (String[]) Array.newInstance("".getClass(), 5);
            BufferedReader in2 =
            new BufferedReader(new InputStreamReader(System.in));
            println("Type the KeyStore file to use  [keystore]");
            args[0]=in2.readLine();
            if (args[0].compareTo("")==0) args[0]="keystore";
            println("Type the password to access it [duitama]");
            args[1]=in2.readLine();
            if (args[1].compareTo("")==0) args[1]="duitama";
            println("Type the DNS name of agent B [localhost]");
            args[2]=in2.readLine();
            if (args[2].compareTo("")==0) args[2]="localhost";
            println("Type the name of agent A [A]");
            args[3]=in2.readLine();
            if (args[3].compareTo("")==0) args[3]="A";
            println("Type the name of agent B [B]");
            args[4]=in2.readLine();
            if (args[4].compareTo("")==0) args[4]="B";
            }
         setKS(args[0],args[1]);
         setIPToId(args[2],"B");
         setNameToId(args[3],"A");
         setNameToId(args[4],"B");
         } catch (Exception e) {e.printStackTrace();}
      return args;
      }
   
   public static void main(String[] args) {
      ObjectOutputStream oos=null;
      try {
         ByteArrayOutputStream os = new ByteArrayOutputStream();
         oos=new ObjectOutputStream(os);
         PrintOOS p=new PrintOOS("INITXAV",oos,os);
         p.start();}
      catch (Exception e) {e.printStackTrace();}
      subMain(args,oos);
      }
   }