package protocols;

import core.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.math.BigInteger;

public class RESPONDER extends Protocol {
   
   static String protoTag="6adc1b80ddc08e287b90e9b4da968770";
   
   public RESPONDER (ObjectOutputStream oos) {
      super("core.Message" ,"core.MessageKey" ,"core.Nonce" );
      this.oos=oos;
      }
   
   public void run() {
      try {
         
         println("creating nonce nb");
         createNewNonce("nb");
         
         println("waiting for m1");
         Message m1 = message(get("a",4000));
         println("Decrypting m1");
         m1.decrypt("RSA", getPrivateKey(nameFromId("b")),protoTag);
         addParts(m1.getAllFields(),2);
         m0=getPart();
         setNameToId(m0.getString(),"a");
         m0=getPart();
         setValueToNonce(m0.getString(),"na");
         
         
         println("Building message m2");
         Message m2 =message();
         m2.addMessage(message(nonceFromId("na")));
         m2.addMessage(message(nonceFromId("nb")));
         println("Encrypting m2");
         m2.encrypt("RSA", getPublicKey(nameFromId("a")),protoTag);
         println("Sending message m2");
         put("a", m2.getString());
         
         println("waiting for m3");
         Message m3 = message(get("a"));
         println("Decrypting m3");
         m3.decrypt("RSA", getPrivateKey(nameFromId("b")),protoTag);
         addParts(m3.getAllFields(),1);
         m0=getPart();
         setValueToNonce(m0.getString(),"nb");
         
         
         writeObject(nameFromId("a"));
         writeObject(nonceFromId("na"));
         writeObject(nonceFromId("nb"));
         
         
         } catch (Exception e) {e.printStackTrace();System.exit(0);}
      }
   
   public static void subMain(String[] args,ObjectOutputStream oos) {
      RESPONDER b;
      while (true) {
         b=new RESPONDER(oos);
         args=b.getArgs(args);
         b.newAgent("a",4000);
         b.start();
         }
      }
   
   public String[] getArgs(String[] args) {
      try {
         if (args.length != 3) {
            args = (String[]) Array.newInstance("".getClass(), 3);
            BufferedReader in2 =
            new BufferedReader(new InputStreamReader(System.in));
            println("Type the KeyStore file to use  [keystore]");
            args[0]=in2.readLine();
            if (args[0].compareTo("")==0) args[0]="keystore";
            println("Type the password to access it [duitama]");
            args[1]=in2.readLine();
            if (args[1].compareTo("")==0) args[1]="duitama";
            println("Type the name of agent b [b]");
            args[2]=in2.readLine();
            if (args[2].compareTo("")==0) args[2]="b";
            }
         setKS(args[0],args[1]);
         setNameToId(args[2],"b");
         } catch (Exception e) {e.printStackTrace();}
      return args;
      }
   
   public static void main(String[] args) {
      ObjectOutputStream oos=null;
      try {
         ByteArrayOutputStream os = new ByteArrayOutputStream();
         oos=new ObjectOutputStream(os);
         PrintOOS p=new PrintOOS("RESPONDER",oos,os);
         p.start();}
      catch (Exception e) {e.printStackTrace();}
      subMain(args,oos);
      }
   }